import pygame
import gamesprite
import vector2
import bonus

class ABO(gamesprite.GameSprite):
    def __init__(self,x=0,y=0,world=0):
        gamesprite.GameSprite.__init__(self,x*world.factorH,y*world.factorV,world.renderWidth,world.renderHeight,world)
        self.loadsprites()
        self.action="stand"
        self.anim=0
        self.animtime=0
        #self.currentFrame=self.southFrames[self.anim]

        self.worldPos=vector2.Vector2(x*self.world.factorH,y*self.world.factorV)
        self.screenPos=self.worldPos-self.world.mapDraw
        self.speed=vector2.Vector2()
        self.thrust=0.
        self.grounded=False
        self.jumping=False
        self.slowed=False

        self.score=0
        
    def loadsprites(self):
        self.currentFrame=pygame.Surface((self.rect.width,self.rect.height))
        self.currentFrame.fill((127,0,0))

    def charge(self):
        self.action="charge"
        if self.debug: print self.thrust
        if self.thrust < 650:
            self.thrust=self.thrust+25

    def jump(self):
        self.action="jump"
        self.grounded=False
        self.jumping=True
        self.jumpTime=0.

    def fall(self):
        self.action="fall"
        self.slowed=False

    def slowFall(self):
        self.action="slowfall"
        self.slowed=True

    def move(self):
        self.worldPos=self.screenPos+self.world.mapDraw
        if self.debug: print self.screenPos,self.worldPos,self.world.mapDraw
        self.rect.left=int(self.screenPos.x)
        self.rect.top=int(self.screenPos.y+self.world.offset)
        if self.debug: print "move",self.rect.left,self.rect.top,self.screenPos,self.world.factorH,self.world.factorV,self.world.offset

    def hit(self):
        self.score=0

    def collect(self,b):
        if isinstance(b,bonus.BMetal):
            self.score += b.value
            print self.score
