import os
import vector2
import ABOMaps
import gamesprite

class BonusTileSet(ABOMaps.TileSet):
    def __init__(self):
        self.filename=os.path.join("images","bonus.png")
        self.name="bonus"

        self.tileWidth=20
        self.tileHeight=20
        self.tileCountH=3
        self.tileCountV=1

class BMetal(gamesprite.GameSprite):
    def __init__(self,x=0,y=0,world=0):
        self.tileset=BonusTileSet()
        self.value=0
        self.sprite=0
        self.tileset.load(world.renderWidth/2,world.renderHeight/2)

        gamesprite.GameSprite.__init__(self,x*world.factorH,y*world.factorV,world.renderWidth,world.renderHeight,world)
        self.action="stand"

        self.worldPos=vector2.Vector2((x+10)*self.world.factorH,(y+10)*self.world.factorV)
        self.screenPos=self.worldPos-self.world.mapDraw

    def loadsprites(self):
        self.currentFrame=self.tileset.tiles[self.sprite]

    def displayFrame(self):
        return self.currentFrame

    def act(self):
        pass
    
class BIron(BMetal):
    def __init__(self,x=0,y=0,world=0):
        BMetal.__init__(self,x,y,world)
        self.value=1
        self.sprite=1
        self.loadsprites()

class BSilver(BMetal):
    def __init__(self,x=0,y=0,world=0):
        BMetal.__init__(self,x,y,world)
        self.value=5
        self.sprite=2
        self.loadsprites()

class BGold(BMetal):
    def __init__(self,x=0,y=0,world=0):
        BMetal.__init__(self,x,y,world)
        self.value=10
        self.sprite=3
        self.loadsprites()
