import vector2

class Role:
    def __init__(self,actor,world):
        self.actor=actor
        self.world=world
        debug=0

    def execute(self):
        pass

class RGroundWalker(Role):
    def __init__(self,actor,world):
        Role.__init__(self,actor,world)
        self.actor.speed.x = 150.
        self.actor.speed.y -= self.world.gravity
    
    def execute(self):
        self.actor.speed.y -= self.world.gravity
        movement = self.actor.speed * self.world.dt
        movement.y = -movement.y # le 0 est en haut de l'ecran avec pygame
        tmpMovement=movement.copy()
        if self.debug: print "start",tmpMovement,self.actor.screenPos
        if movement.y > 0: # mouvement vers le bas
            boundPosy=self.actor.worldPos.y+self.world.renderHeight+movement.y
            boundPosx=self.actor.worldPos.x
            boundPosx2=self.actor.worldPos.x+self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosx2=int(boundPosx2)/self.world.renderWidth
            if self.debug: print self.actor.worldPos,movement.y,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&1 or self.world.map.boundMapData[boundMapPosy][boundMapPosx2]&1:
                tmpMovement.y = movement.y-int(boundPosy)%self.world.renderHeight
                self.actor.speed.y = 0.
        if movement.x > 0: # mouvement vers la droitee
            boundPosx=self.actor.worldPos.x+self.world.renderWidth+movement.x
            boundPosy=self.actor.worldPos.y
            boundPosy2=self.actor.worldPos.y+self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosy2=int(boundPosy2)/self.world.renderHeight
            if self.debug: print "bound",self.actor.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&2 or self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&2 or (self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&1 == 0):
                tmpMovement.x = movement.x-int(boundPosx)%self.world.renderWidth
                self.actor.speed.x = -150.
        if movement.x < 0: # mouvement vers la gauche
            boundPosx=self.actor.worldPos.x+movement.x
            boundPosy=self.actor.worldPos.y
            boundPosy2=self.actor.worldPos.y+self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosy2=int(boundPosy2)/self.world.renderHeight
            if self.debug: print "bound",self.actor.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&8 or self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&8 or (self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&1 == 0):
                tmpMovement.x = movement.x+self.world.renderWidth-int(boundPosx)%self.world.renderWidth
                self.actor.speed.x = 150.
        self.actor.worldPos.x += tmpMovement.x*self.world.factorH
        self.actor.worldPos.y += tmpMovement.y*self.world.factorV

class RAirWalker(Role):
    def __init__(self,actor,world):
        Role.__init__(self,actor,world)
        self.actor.speed.x = 150.
        self.actor.speed.y = 0.
    
    def execute(self):
        self.actor.speed.y -= self.world.gravity
        movement = self.actor.speed * self.world.dt
        movement.y = -movement.y # le 0 est en haut de l'ecran avec pygame
        tmpMovement=movement.copy()
        if self.debug: print "start",tmpMovement,self.actor.screenPos
        if movement.y > 0: # mouvement vers le bas
            boundPosy=self.actor.worldPos.y+self.world.renderHeight+movement.y
            boundPosx=self.actor.worldPos.x
            boundPosx2=self.actor.worldPos.x+self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosx2=int(boundPosx2)/self.world.renderWidth
            if self.debug: print self.actor.worldPos,movement.y,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&1 or self.world.map.boundMapData[boundMapPosy][boundMapPosx2]&1:
                tmpMovement.y = movement.y-int(boundPosy)%self.world.renderHeight
                self.actor.speed.y = 0.
        if movement.x > 0: # mouvement vers la droitee
            boundPosx=self.actor.worldPos.x+self.world.renderWidth+movement.x
            boundPosy=self.actor.worldPos.y
            boundPosy2=self.actor.worldPos.y+self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosy2=int(boundPosy2)/self.world.renderHeight
            if self.debug: print "bound",self.actor.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&2 or self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&2:
                tmpMovement.x = movement.x-int(boundPosx)%self.world.renderWidth
                self.actor.speed.x = -150.
        if movement.x < 0: # mouvement vers la gauche
            boundPosx=self.actor.worldPos.x+movement.x
            boundPosy=self.actor.worldPos.y
            boundPosy2=self.actor.worldPos.y+self.world.renderHeight
            boundMapPosx=int(boundPosx)/self.world.renderWidth
            boundMapPosy=int(boundPosy)/self.world.renderHeight
            boundMapPosy2=int(boundPosy2)/self.world.renderHeight
            if self.debug: print "bound",self.actor.worldPos,movement.x,boundPosx,boundPosy,boundMapPosx,boundMapPosy
            if self.world.map.boundMapData[boundMapPosy][boundMapPosx]&8 or self.world.map.boundMapData[boundMapPosy2][boundMapPosx]&8:
                tmpMovement.x = movement.x+self.world.renderWidth-int(boundPosx)%self.world.renderWidth
                self.actor.speed.x = 150.
        self.actor.worldPos.x += tmpMovement.x*self.world.factorH
        self.actor.worldPos.y += tmpMovement.y*self.world.factorV
